HMWKGraph Class Reference

the main class to read the graphic part of a HanMac Word file More...

`#include <HMWKGraph.hxx>`

## Public Member Functions

| HMWKGraph (HMWKParser &parser)
| constructor More...
virtual | ~HMWKGraph ()
| destructor More...
int | version () const
| returns the file version More...
int | numPages () const
| returns the number of pages More...

## Protected Member Functions

bool | getColor (int colId, int patternId, MWAWColor &color) const
| returns the color associated with a pattern More...
bool | sendPageGraphics (std::vector< long > const &doNotSendIds)
| try to send the page graphic More...
void | flushExtra ()
| sends the data which have not yet been sent to the listener More...
bool | readFrames (shared_ptr< HMWKZone > zone)
| try to read the frame definition (type 2) More...
bool | readPicture (shared_ptr< HMWKZone > zone)
| try to read a picture zone (type d) More...
bool | sendFrame (long frameId, MWAWPosition pos, WPXPropertyList extras=WPXPropertyList())
| try to send a frame to the listener More...
bool | sendPicture (long pictId, MWAWPosition pos, WPXPropertyList extras=WPXPropertyList())
| try to send a picture to the listener More...
bool | sendText (long textId, long id)
| ask main parser to send a text zone More...
std::map< long, int > | getTextFrameInformations () const
| return a list textZId -> type which 3(footnote), 4(textbox), 9(table), 10(comment) More...
bool | sendPicture (HMWKGraphInternal::Picture const &picture, MWAWPosition pos, WPXPropertyList extras=WPXPropertyList())
| try to send a picture to the listener More...
bool | sendFrame (HMWKGraphInternal::Frame const &frame, MWAWPosition pos, WPXPropertyList extras=WPXPropertyList())
| try to send a frame to the listener More...
bool | sendBasicGraph (HMWKGraphInternal::BasicGraph const &pict, MWAWPosition pos, WPXPropertyList extras=WPXPropertyList())
| try to send a basic picture to the listener More...
bool | sendPictureFrame (HMWKGraphInternal::PictureFrame const &pict, MWAWPosition pos, WPXPropertyList extras=WPXPropertyList())
| try to send a picture frame More...
bool | sendEmptyPicture (MWAWPosition pos)
| try to send an empty picture More...
bool | sendTextBox (HMWKGraphInternal::TextBox const &textbox, MWAWPosition pos, WPXPropertyList extras=WPXPropertyList())
| try to send a textbox to the listener More...
bool | sendTableUnformatted (long fId)
| try to send a table unformatted More...
shared_ptr < HMWKGraphInternal::BasicGraph > | readBasicGraph (shared_ptr< HMWKZone > zone, HMWKGraphInternal::Frame const &header)
| try to read the basic graph data More...
shared_ptr < HMWKGraphInternal::FootnoteFrame > | readFootnoteFrame (shared_ptr< HMWKZone > zone, HMWKGraphInternal::Frame const &header)
| try to read the footnote data More...
shared_ptr < HMWKGraphInternal::Group > | readGroup (shared_ptr< HMWKZone > zone, HMWKGraphInternal::Frame const &header)
| try to read the group data More...
shared_ptr < HMWKGraphInternal::PictureFrame > | readPictureFrame (shared_ptr< HMWKZone > zone, HMWKGraphInternal::Frame const &header)
| try to read the picture data More...
shared_ptr < HMWKGraphInternal::Table > | readTable (shared_ptr< HMWKZone > zone, HMWKGraphInternal::Frame const &header)
| try to read the table data More...
shared_ptr < HMWKGraphInternal::TextBox > | readTextBox (shared_ptr< HMWKZone > zone, HMWKGraphInternal::Frame const &header, bool isMemo)
| try to read the textbox data More...

## Protected Attributes

MWAWParserStatePtr | m_parserState
| the parser state More...
shared_ptr < HMWKGraphInternal::State > | m_state
| the state More...
HMWKParser * | m_mainParser
| the main parser; More...

## Private Member Functions

| HMWKGraph (HMWKGraph const &orig)
HMWKGraph & | operator= (HMWKGraph const &orig)

## Friends

class | HMWKParser
class | HMWKGraphInternal::SubDocument
struct | HMWKGraphInternal::Table

## Detailed Description

the main class to read the graphic part of a HanMac Word file

## Constructor & Destructor Documentation

HMWKGraph::HMWKGraph | ( | HMWKParser & | parser | ) |

constructor

HMWKGraph::~HMWKGraph | ( |  | ) |

virtual

destructor

HMWKGraph::HMWKGraph | ( | HMWKGraph const & | orig | ) |

private

## Member Function Documentation

void HMWKGraph::flushExtra | ( |  | ) |

protected

sends the data which have not yet been sent to the listener

bool HMWKGraph::getColor | ( | int | colId,
|  | int | patternId,
|  | MWAWColor & | color
| ) |  | const

protected

returns the color associated with a pattern

std::map< long, int > HMWKGraph::getTextFrameInformations | ( |  | ) | const

protected

return a list textZId -> type which 3(footnote), 4(textbox), 9(table), 10(comment)

int HMWKGraph::numPages | ( |  | ) | const

returns the number of pages

HMWKGraph& HMWKGraph::operator= | ( | HMWKGraph const & | orig | ) |

private

shared_ptr< HMWKGraphInternal::BasicGraph > HMWKGraph::readBasicGraph | ( | shared_ptr< HMWKZone > | zone,
|  | HMWKGraphInternal::Frame const & | header
| ) |  |

protected

try to read the basic graph data

Referenced by readFrames().

shared_ptr< HMWKGraphInternal::FootnoteFrame > HMWKGraph::readFootnoteFrame | ( | shared_ptr< HMWKZone > | zone,
|  | HMWKGraphInternal::Frame const & | header
| ) |  |

protected

try to read the footnote data

Referenced by readFrames().

bool HMWKGraph::readFrames | ( | shared_ptr< HMWKZone > | zone | ) |

protected

try to read the frame definition (type 2)

shared_ptr< HMWKGraphInternal::Group > HMWKGraph::readGroup | ( | shared_ptr< HMWKZone > | zone,
|  | HMWKGraphInternal::Frame const & | header
| ) |  |

protected

try to read the group data

Referenced by readFrames().

bool HMWKGraph::readPicture | ( | shared_ptr< HMWKZone > | zone | ) |

protected

try to read a picture zone (type d)

shared_ptr< HMWKGraphInternal::PictureFrame > HMWKGraph::readPictureFrame | ( | shared_ptr< HMWKZone > | zone,
|  | HMWKGraphInternal::Frame const & | header
| ) |  |

protected

try to read the picture data

Referenced by readFrames().

shared_ptr< HMWKGraphInternal::Table > HMWKGraph::readTable | ( | shared_ptr< HMWKZone > | zone,
|  | HMWKGraphInternal::Frame const & | header
| ) |  |

protected

try to read the table data

Referenced by readFrames().

shared_ptr< HMWKGraphInternal::TextBox > HMWKGraph::readTextBox | ( | shared_ptr< HMWKZone > | zone,
|  | HMWKGraphInternal::Frame const & | header,
|  | bool | isMemo
| ) |  |

protected

try to read the textbox data

Referenced by readFrames().

bool HMWKGraph::sendBasicGraph | ( | HMWKGraphInternal::BasicGraph const & | pict,
|  | MWAWPosition | pos,
|  | WPXPropertyList | extras = `WPXPropertyList()`
| ) |  |

protected

try to send a basic picture to the listener

Referenced by sendFrame().

bool HMWKGraph::sendEmptyPicture | ( | MWAWPosition | pos | ) |

protected

try to send an empty picture

Referenced by HMWKGraphInternal::SubDocument::parse().

bool HMWKGraph::sendFrame | ( | long | frameId,
|  | MWAWPosition | pos,
|  | WPXPropertyList | extras = `WPXPropertyList()`
| ) |  |

protected

try to send a frame to the listener

Referenced by flushExtra(), HMWKGraphInternal::SubDocument::parse(), and sendPageGraphics().

bool HMWKGraph::sendFrame | ( | HMWKGraphInternal::Frame const & | frame,
|  | MWAWPosition | pos,
|  | WPXPropertyList | extras = `WPXPropertyList()`
| ) |  |

protected

try to send a frame to the listener

bool HMWKGraph::sendPageGraphics | ( | std::vector< long > const & | doNotSendIds | ) |

protected

try to send the page graphic

bool HMWKGraph::sendPicture | ( | long | pictId,
|  | MWAWPosition | pos,
|  | WPXPropertyList | extras = `WPXPropertyList()`
| ) |  |

protected

try to send a picture to the listener

Referenced by flushExtra(), HMWKGraphInternal::SubDocument::parse(), and sendPictureFrame().

bool HMWKGraph::sendPicture | ( | HMWKGraphInternal::Picture const & | picture,
|  | MWAWPosition | pos,
|  | WPXPropertyList | extras = `WPXPropertyList()`
| ) |  |

protected

try to send a picture to the listener

bool HMWKGraph::sendPictureFrame | ( | HMWKGraphInternal::PictureFrame const & | pict,
|  | MWAWPosition | pos,
|  | WPXPropertyList | extras = `WPXPropertyList()`
| ) |  |

protected

try to send a picture frame

Referenced by sendFrame().

bool HMWKGraph::sendTableUnformatted | ( | long | fId | ) |

protected

try to send a table unformatted

Referenced by HMWKGraphInternal::SubDocument::parse().

bool HMWKGraph::sendText | ( | long | textId,
|  | long | id
| ) |  |

protected

ask main parser to send a text zone

Referenced by HMWKGraphInternal::SubDocument::parse(), and HMWKGraphInternal::Table::sendText().

bool HMWKGraph::sendTextBox | ( | HMWKGraphInternal::TextBox const & | textbox,
|  | MWAWPosition | pos,
|  | WPXPropertyList | extras = `WPXPropertyList()`
| ) |  |

protected

try to send a textbox to the listener

Referenced by sendFrame().

int HMWKGraph::version | ( |  | ) | const

returns the file version

## Friends And Related Function Documentation

friend class HMWKGraphInternal::SubDocument

friend

friend struct HMWKGraphInternal::Table

friend

friend class HMWKParser

friend

## Member Data Documentation

HMWKParser* HMWKGraph::m_mainParser

protected

the main parser;

Referenced by sendText().

MWAWParserStatePtr HMWKGraph::m_parserState

protected

the parser state

Referenced by sendBasicGraph(), sendEmptyPicture(), sendFrame(), sendPicture(), sendPictureFrame(), sendTableUnformatted(), sendTextBox(), and version().

shared_ptr<HMWKGraphInternal::State> HMWKGraph::m_state

protected

the state

Referenced by flushExtra(), getColor(), getTextFrameInformations(), numPages(), readFrames(), readPicture(), readTable(), sendFrame(), sendPageGraphics(), sendPicture(), and sendTableUnformatted().

The documentation for this class was generated from the following files:

- HMWKGraph.hxx
- HMWKGraph.cxx